<?php

require_once "prepend.php";

class XEmb_Config
{
  var $xemb_ini_file = "";
  var $options = array();

  function XEmb_Config()
  {
    $this->xemb_ini_file      = dirname(__FILE__).'/../../../conf/xemb.ini';
    touch($this->xemb_ini_file);
    $default_options["cache"] = true;
    $default_options["meta_default"]  = true;
    if (is_writable($this->xemb_ini_file))
      $this->options = array_merge( $default_options, iniFile::read($this->xemb_ini_file, true) );
    else
      $this->options = $default_options;
  }

  function &Instance()
  {
    static $instance;
    
    if (!isset($instance))
      $instance = new XEmb_Config();
    return $instance;
  }

  function GetAppVersion()
  {
    return "1.1";
  }

  function GetAppName()
  {
    return "XEmb";
  }

  function GetAppAuteur()
  {
    return "Stephane Gully";
  }

  function GetAppHelpURL()
  {
    return "http://www.zeitoun.net/index.php?2005/04/14/28-xemb-un-plugin-pour-dotclear";
  }

  function ConfigIsWritable()
  {
    $instance =& XEmb_Config::Instance();
    touch($instance->xemb_ini_file);
    return is_writable($instance->xemb_ini_file);
  }

  function GetOption($option)
  { 
    $instance =& XEmb_Config::Instance();
    return $instance->options[$option];
  }

  function SetOption($option, $value)
  {
    $instance =& XEmb_Config::Instance();
    $objIni = new iniFile($instance->xemb_ini_file);
    $objIni->editVar($option, $value);
    $objIni->saveFile();
    $instance->options[$option] = $value;
  }

};

?>