<?php

require_once "prepend.php";
require_once "XEmb_Transformations.class.php";

class XEmb
{
  /**
   * Utilise pour afficher le titre d'un billet dans <title>...</title>
   */
  function dcSinglePostTitle($s='%s - ')
  {
    if ($GLOBALS['mode'] != 'post')
      return;

    $xemb_tr =& XEmb_Transformations::Instance();
    $content =& $GLOBALS['news']->getContent();
    $res = $xemb_tr->searchPatternMatch( $content );
    if (!$res["ok"])
      {
        // comportement normal de dotclear (le billet n'utilise pas le plugin XEmb)
        dcSinglePostTitle($s);
      }
    else
      {
        // on recupere notre article depuis l'url et on l'affiche
        printf($s, $xemb_tr->getTitle($res["url"]));
      }
    
  }
  
  /**
   * Affiche le titre de l'article.
   * Si ce n'est pas un XEmb on utilise la fonction de dotclear.
   */
  function dcPostTitle($s='%s')
  {
    $xemb_tr =& XEmb_Transformations::Instance();
    $content =& $GLOBALS['news']->getContent();
    $res = $xemb_tr->searchPatternMatch( $content );
    if (!$res["ok"])
      {
        // comportement normal de dotclear (le billet n'utilise pas le plugin XEmb)
        dcPostTitle($s);
      }
    else
      {
        // on recupere notre article depuis l'url et on l'affiche
        printf($s, $xemb_tr->getTitle($res["url"]));
      }
  }
  
  /**
   * Affiche le contenu de l'article.
   * Si ce n'est pas un XEmb on utilise la fonction de dotclear.
   */
  function dcPostContent($part=0)
  {
    $xemb_tr =& XEmb_Transformations::Instance();
    $content =& $GLOBALS['news']->getContent();
    $id      = $GLOBALS['news']->f('post_id');
    $res = $xemb_tr->searchPatternMatch( $content );
    if (!$res["ok"])
      {
        // comportement normal de dotclear (le billet n'utilise pas le plugin XEmb)
        dcPostContent($part);
      }
    else
      {
        // @todo : grer le parametres $part : il indique le nombre de mots  afficher (0 = tout le billet)
        echo "<div class=\"xemb\">\n";
        // on recupere notre article depuis l'url
        echo $xemb_tr->getContent($res["url"]);
        echo "</div>\n";
        echo "<p class=\"info-xemb\" style=\"float: right;\">Billet gnr par <a href=\"".
          XEmb_Config::GetAppHelpURL()."\">".
          XEmb_Config::GetAppName()." v".
          XEmb_Config::GetAppVersion()."</a> de <a href=\"http://www.zeitoun.net\">".
          XEmb_Config::GetAppAuteur()."</a></p>\n";
      }
  }

  /**
   * Affiche le chapo de l'article.
   * On n'affiche rien si le billet utilise XEmb et n'a pas de chapo
   * Si ce n'est pas un XEmb on utilise la fonction de dotclear.
   */
  function dcPostChapo($s='%s <hr />')
  {
    $xemb_tr =& XEmb_Transformations::Instance();
    $content =& $GLOBALS['news']->getContent();
    $id      = $GLOBALS['news']->f('post_id');
    $res = $xemb_tr->searchPatternMatch( $content );
    if (!$res["ok"] || $res["chapo"] == "yes")
      dcPostChapo($s);
  }

  /**
   * Affiche le resume de l'article (le chapo ou le debut du contenu).
   * Si c'est un XEmb on ne fait rien car il faudrait trouver un moyen d'afficher le debut du getContent.
   */
  function dcPostAbstract($s='%s',$l='<p><a href="%s">lire la suite</a></p>')
  {
    if ($GLOBALS['news']->f('post_chapo') != '') {
      printf($s,$GLOBALS['news']->getChapo());
      printf($l,$GLOBALS['news']->getPermURL());
    } else {
      // on est dans la liste des post et on n'a pas de chapo a afficher
      // on ne fait rien car : je n'ai pas trouve de solutions pour associer simplement les feuilles de style dans le <head> (a la limite on ne met pas de feuilles de style), il faudrait trouver un moyen de n'afficher que un bout du debut de l'article (sorte de chapo?)
    }
  }

  /**
   * Affiche le contenu des meta de l'article (pas de fonction equivalent dans dotclear).
   * Les meta donnees concernent surtout les feuilles de style.
   */
  function dcPostMeta()
  {
    $xemb_tr =& XEmb_Transformations::Instance();
    // on n'insere pas de meta si on est dans la liste des billets (plus d'un billet)
    // @todo : a clarifier
    if ( count($GLOBALS['news']->arry_data) == 1 )
      {
        $content =& $GLOBALS['news']->getContent();
        $id      = $GLOBALS['news']->f('post_id');
        $res = $xemb_tr->searchPatternMatch( $content );
        if ( $res["ok"] && // notre billet utilise le plugin XEmb
             $res["meta"] == "yes" && // et notre billet veut ajouter les meta
             $GLOBALS['news']->f('post_id') ) // et nous ne somme pas dans la liste des billets (cad nous somme dans l'affichage d'un seul billet)
          echo $xemb_tr->getMeta($res["url"]);
      }
  }
};



?>
